#ifndef _MYLIBPNG_H_
#define _MYLIBPNG_H_

/* 
 * Structure to hold raw image data
 */
typedef struct mylibpng_image_t {
	uint32_t width;		/* Image width */
	uint32_t height;	/* Image height */
	uint8_t depth;		/* Image depth */
	uint8_t real_depth; 	/* Depth in bytes/pixel */

	unsigned char *data;	/* Raw image data */	
} * pngimage;

/* 
 * 8-bit color structure
 */ 
typedef struct mylibpng_color8_t {
	uint8_t r;		/* Red */
	uint8_t g;		/* Green */
	uint8_t b;		/* Blue */
	float	opacity;	/* Opacity */
	
} pngcolor8;

/* Function prototypes */
pngimage mypng_new(uint32_t, uint32_t, uint8_t);
void	 mypng_destroy(pngimage);
int	 mypng_write(pngimage, char *);
pngimage mypng_read(char *);
void	 mypng_fill8(pngimage, pngcolor8 *);
void	 mypng_plot8(pngimage, uint32_t, uint32_t, pngcolor8 *);
void	 mypng_plot8_opacity(pngimage, uint32_t, uint32_t, pngcolor8 *);
void	 mypng_get8(pngimage, uint32_t, uint32_t, pngcolor8 *);
void	 mypng_box8(pngimage, uint32_t, uint32_t, uint32_t, uint32_t, pngcolor8 *);
void	 mypng_box8_opacity(pngimage, uint32_t, uint32_t, uint32_t, uint32_t, pngcolor8 *);

#endif /* _MYLIBPNG_H_ */
